<?php

namespace Magento\FirstDataGateway\Helper;

use \Magento\Framework\App\Helper\AbstractHelper;

class Cdata extends AbstractHelper
{

	public function getCdata($d, $sharedKey) {
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
        $base = $storeManager->getStore()->getBaseUrl();
        $order = $objectManager->create('Magento\Sales\Model\Order')->loadByIncrementId($d['oid']);
        $sessId = md5($d['oid'] . $sharedKey);
        if(!$order || ($d['hashExtended'] != $sessId)) return 'err2';
        if($order->getCustomerEmail() != $d['email']) return 'err3';
        $curr = $d['currency'] == '985' ? 'PLN' : '';
        if((floatval($order->getBaseGrandTotal()) != $d['chargetotal']) || ($order->getBaseCurrencyCode() != $curr)) return 'err4';

        unset($d['hashExtended']);
        $d['responseFailURL'] = $base . 'firstdata/update/error';
        $d['responseSuccessURL'] = $base . 'firstdata/update/success';
        $d['transactionNotificationURL'] = $base . 'firstdata/update/update';
        ksort($d);
        $stringToHash = join('|', $d);
//        error_log('k=' . $sharedKey . ' h='.$stringToHash);
        $hash = hash_hmac('sha256', $stringToHash, $sharedKey, true);
        
        return base64_encode($hash);
        
    }

}

?>
