<?php

namespace Magento\FirstDataGateway\Observer;

use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer;


class OrderCancelObserver implements ObserverInterface {
	protected $helper;
	
	public function __construct(
		\Magento\FirstDataGateway\Helper\Api $helper
	)
	{
		$this->helper = $helper;
	}
	
    public function execute(Observer $observer) {
        $order = $observer->getEvent()->getOrder();
        if(!$this->scopeConfig->getValue('payment/firstdata_gateway/auto_zwrot')) return;
        $this->helper->zwrot($order->getId());
    }
}

?>
